import serial
import time
import struct

TICKS_PER_UNIT_DIST = 1000;
TICKS_PER_UNIT_DEG = 7;

class BigTrak:
  def __init__(self):
    # make sure the pinmux settings are okay
    fw = file("/sys/kernel/debug/omap_mux/uart1_rxd", "w")
    fw.write("%X" % (0 | (1 << 5))) # pin mode 0 (uart1_rxd) and direction input
    fw.close()
    fw = file("/sys/kernel/debug/omap_mux/uart1_txd", "w")
    fw.write("%X" % (0)) # pin mode 0 (uart1_txd) and direction output
    fw.close()
    fw = file("/sys/class/gpio/export", "w")
    fw.write("113")
    try:
      fw.close()
    except:
      pass
    fw = file("/sys/class/gpio/export", "w")
    fw.write("112")
    try:
      fw.close()
    except:
      pass
    fw = file("/sys/class/gpio/gpio112/direction", "w")
    fw.write("in")
    fw.close()
    fw = file("/sys/class/gpio/gpio113/direction", "w")
    fw.write("out")
    fw.close()
    self.s = serial.Serial("/dev/ttyO1", baudrate=9600)

  def wait_ready(self):
    r = '1'
    time.sleep(0.1)
    while r.strip() == '1':
      fr = file("/sys/class/gpio/gpio112/value", "r")
      r = fr.read()
      fr.close()

  def send(self, vala, valb):
    self.s.write(struct.pack("ii", vala, valb).replace("\xAA", "\xAA\xAA").replace("\xA5", "\xAA\xA5") + "\xA5")
    self.wait_ready()

  def forward(self, count):
    self.send(count * TICKS_PER_UNIT_DIST, count * TICKS_PER_UNIT_DIST)

  def back(self, count):
    self.send(-count * TICKS_PER_UNIT_DIST, -count * TICKS_PER_UNIT_DIST)

  def left(self, count):
    self.send(count * TICKS_PER_UNIT_DEG, -count * TICKS_PER_UNIT_DEG)

  def right(self, count):
    self.send(-count * TICKS_PER_UNIT_DEG, count * TICKS_PER_UNIT_DEG)

  def fire(self):
    for i in range(5):
      fw = file("/sys/class/gpio/gpio113/value", "w")
      fw.write("1")
      fw.close()
      time.sleep(1)
      fw = file("/sys/class/gpio/gpio113/value", "w")
      fw.write("0")
      fw.close()
      time.sleep(1)

